// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_PRINCIPAL_H
#define OB_PRINCIPAL_H

namespace CORBA
{

class Principal;
typedef Principal* Principal_ptr;
typedef Principal_ptr PrincipalRef;

} // End of namespace CORBA

void OBDuplicate(CORBA::Principal_ptr);
void OBRelease(CORBA::Principal_ptr);

namespace CORBA
{

//
// The Principal class
//
typedef OB::ObjVar< Principal > Principal_var;

class Principal : public OB::RefCount
{
    //
    // Hide copy-constructor and assignment operator
    //
    Principal(const Principal&);
    void operator=(const Principal&);

protected:

    Principal() { };

public:

    //
    // Standard IDL to C++ Mapping
    //
    static inline Principal_ptr _duplicate(Principal_ptr p)
    { if(p) p -> _OB_incRef(); return p; }
    static inline Principal_ptr _nil()
    { return 0; }
};

inline void
release(Principal_ptr p)
{
    if(p)
	p -> _OB_decRef();
}

inline Boolean
is_nil(Principal_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

#endif
